Index: /mods/wpsg_mod_export.class.php
===================================================================
--- /mods/wpsg_mod_export.class.php	(revision 7799)
+++ /mods/wpsg_mod_export.class.php	(revision 7804)
@@ -302,317 +302,317 @@
 					`export_type` = '".self::TYPE_ORDER."'
 			");
-			
-			if (sizeof($this->shop->view['wpsg_mod_export']['arProfile']) <= 0) return;
-			
-			$arTabs['left'][$this->id] = array(
-				'tab_title' => __('Bestellexport', 'wpsg'),
-				'tab_icon' => 'glyphicon glyphicon-export',
-				'tab_content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_export/order_index_tab.phtml', false)
-			);
-
-		} // public function order_index_tab(&$arTabs)
-		 		  		
-		public function be_ajax()
-		{ 
-			
-			if ($_REQUEST['do'] == 'wpsg_mod_export_addProfil')
-			{
-				
-				$new_id = $this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE, array(
-					'name' => wpsg_q(__('Neues Profil', 'wpsg')),
-					'filename' => 'export.csv',
-					'export_type' => wpsg_q($_REQUEST['type']),
-					'file_encoding' => wpsg_q(self::ENCODING_UTF8),
-					'field_delimiter' => ';',
-					'field_enclosure' => '"',
-					'field_escape' => wpsg_q('\\'),
-					'format' => wpsg_q(self::FORMAT_CSV)
-				));
-				
-				die($this->profilList($new_id));
-				
-			}
-			else if ($_REQUEST['do'] == 'handleExport')
-			{
-				
-				die($this->handleExport());
-				
-			}
-			else if ($_REQUEST['do'] == 'wpsg_mod_export_removeProfil')
-			{
-				
-				$this->db->Query("DELETE FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil'])."'");
-				
-				die($this->profilList());
-				
-			}
-			else if ($_REQUEST['do'] == 'wpsg_mod_export_removeField')
-			{
-				
-				$this->db->Query("DELETE FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `id` = '".wpsg_q($_REQUEST['field_id'])."' ");
-				
-				die("1");
-				
-			}
-			else if ($_REQUEST['do'] == 'wpsg_mod_export_reorder')
-			{
-				
-				parse_str($_REQUEST['wpsg_reorder'], $reorder);
-			
-				foreach ($reorder['field'] as $k => $field_id)
-				{
-					
-					$this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
-						'pos' => wpsg_q($k)
-					), " `id` = '".wpsg_q($field_id)."' ");
-					
-				}
-				
-				die("1");
-				
-			}
-			else if ($_REQUEST['do'] == 'wpsg_mod_export_addField')
-			{
-                
+
+            if (sizeof($this->shop->view['wpsg_mod_export']['arProfile']) <= 0) return;
+
+            $arTabs['left'][$this->id] = array(
+                'tab_title' => __('Bestellexport', 'wpsg'),
+                'tab_icon' => 'glyphicon glyphicon-export',
+                'tab_content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_export/order_index_tab.phtml', false)
+            );
+
+        } // public function order_index_tab(&$arTabs)
+
+        public function be_ajax()
+        {
+
+            if ($_REQUEST['do'] == 'wpsg_mod_export_addProfil')
+            {
+
+                $new_id = $this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE, array(
+                    'name' => wpsg_q(__('Neues Profil', 'wpsg')),
+                    'filename' => 'export.csv',
+                    'export_type' => wpsg_q($_REQUEST['type']),
+                    'file_encoding' => wpsg_q(self::ENCODING_UTF8),
+                    'field_delimiter' => ';',
+                    'field_enclosure' => '"',
+                    'field_escape' => wpsg_q('\\'),
+                    'format' => wpsg_q(self::FORMAT_CSV)
+                ));
+
+                die($this->profilList($new_id));
+
+            }
+            else if ($_REQUEST['do'] == 'handleExport')
+            {
+
+                die($this->handleExport());
+
+            }
+            else if ($_REQUEST['do'] == 'wpsg_mod_export_removeProfil')
+            {
+
+                $this->db->Query("DELETE FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil'])."'");
+
+                die($this->profilList());
+
+            }
+            else if ($_REQUEST['do'] == 'wpsg_mod_export_removeField')
+            {
+
+                $this->db->Query("DELETE FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `id` = '".wpsg_q($_REQUEST['field_id'])."' ");
+
+                die("1");
+
+            }
+            else if ($_REQUEST['do'] == 'wpsg_mod_export_reorder')
+            {
+
+                parse_str($_REQUEST['wpsg_reorder'], $reorder);
+
+                foreach ($reorder['field'] as $k => $field_id)
+                {
+
+                    $this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
+                        'pos' => wpsg_q($k)
+                    ), " `id` = '".wpsg_q($field_id)."' ");
+
+                }
+
+                die("1");
+
+            }
+            else if ($_REQUEST['do'] == 'wpsg_mod_export_addField')
+            {
+
                 $max_pos = $this->db->fetchOne("SELECT MAX(`pos`) FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `profil_id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
-				
-				$this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
-					'profil_id' => wpsg_q($_REQUEST['profil_id']),
-					'name' => __('Neues Feld', 'wpsg'),
+
+                $this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
+                    'profil_id' => wpsg_q($_REQUEST['profil_id']),
+                    'name' => __('Neues Feld', 'wpsg'),
                     'pos' => wpsg_q($max_pos + 1),
-					'value_key' => '-1'
-				));
-				
-				die($this->renderFields($this->loadProfil($_REQUEST['profil_id'])));
-				
-			}
-			else if ($_REQUEST['do'] == 'wpsg_mod_export_profilSwitch')
-			{
-				
-				die($this->renderProfil($_REQUEST['profil']));
-								
-			}
-			else if ($_REQUEST['do'] == 'save')
-			{
-				
-				$arProfil = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
-				$arProfil['fields'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `profil_id` = '".wpsg_q($arProfil['id'])."' ");
-				
-				wpsg_header::startDownloadContent('profil.json', json_encode($arProfil));
-				exit;
-				
-			}
-			else if ($_REQUEST['do'] == 'import')
-			{
-				
-				$content = file_get_contents($_FILES['profil_file']['tmp_name']);
-				$content = wpsg_removeBOM($content);
-				$arData = @json_decode($content, true);
-				
-				if (!wpsg_isSizedArray($arData))
-				{
-					
-					$this->shop->addBackendError(wpsg_translate(__('Datei ist keine gÃŒltige Profildatei. Error: #1#', 'wpsg'), json_last_error_msg()));
-										
-				}
-				else
-				{
-					
-					$arFields = $arData['fields']; unset($arData['fields']);
-					
-					unset($arData['id']); 
-					unset($arData['cron_lastrun']);
-					
-					$profil_id = $this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE, wpsg_q($arData), true);
-					
-					foreach ($arFields as $field_data)
-					{
-						
-						unset($field_data['id']);
-						$field_data['profil_id'] = $profil_id;
-						
-						$this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, wpsg_q($field_data), true);
-						
-					}
-					
-					$this->shop->addBackendMessage(wpsg_translate(__('Profil als "#1#" erfolgreich importiert.', 'wpsg'), $arData['name']));
-					
-				}
-				
-				$this->shop->redirect(WPSG_URL_WP.'wp-admin/admin.php?page=wpsg-Admin&action=module&modul=wpsg_mod_export');
-				
-			}
-			else if ($_REQUEST['do'] == 'inlinedit')
-			{
-
-				if (preg_match('/field_/', $_REQUEST['name']) && !in_array($_REQUEST['name'], ['field_delimiter', 'field_enclosure', 'field_escape']))
-				{
-
-					// Feldwert wurde bearbeitet
-					$field_id = preg_replace('/(.*)\_/', '', $_REQUEST['name']);
-					$col = preg_replace('/\_\d+$/', '', $_REQUEST['name']);
-								
-					switch ($col) 
-					{
-						
-						case 'field_name': $col = 'name'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-						case 'field_format': $col = 'format'; break;
-						case 'field_userformat': $col = 'userformat'; break;
-						case 'field_typ': $col = 'value_key'; break;
-						case 'field_xml_att': $col = 'xml_att'; break;
-						
-						default: throw new \Exception(__('UngÃŒltiger Feldname (Feld)', 'wpsg'));
-							
-					}
-					
-					$this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
-						wpsg_q($col) => wpsg_q(wpsg_xss($_REQUEST['value']))
-					), " `id` = '".wpsg_q($field_id)."' ");
-					
-					echo $this->db->fetchOne("SELECT `".wpsg_q($col)."` FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `id` = '".wpsg_q($field_id)."' "); 
-					exit;
-					
-				}
-				else if (preg_match('/orderfilter_/', $_REQUEST['name']))
-				{
-
-					// Wert aus dem Bestellfilter wurde bearbeitet					
-					$col = substr($_REQUEST['name'], 12);
-								
-					switch ($col) 
-					{
-						
-						case 's': $col = 's'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-						case 'k_id': $col = 'k_id'; break;
-						case 'status': $col = 'status'; break;
-						case 'cdate_m': $col = 'cdate_m'; break;
-						case 'cdate_y': $col = 'cdate_y'; break;
-						case 'invoicedate_m': $col = 'invoicedate_m'; break;
-						case 'productgroup_ids': $col = 'productgroup_ids'; break;
-						case 'productcategory_ids': $col = 'productcategory_ids'; break;
-											
-						default: throw new \Exception(__('UngÃŒltiger Feldname (Bestellfilter)', 'wpsg'));
-							
-					}
-					
-					$orderfilter = $this->db->fetchOne("SELECT `orderfilter` FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
-					$orderfilter = @unserialize($orderfilter);
-					if (!is_array($orderfilter)) $orderfilter = array();
-					
-					$orderfilter[$col] = $_REQUEST['value'];
-					
-					$this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE, array('orderfilter' => wpsg_q(serialize($orderfilter))), " `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
-					
-					echo $orderfilter[$col];
-					exit;
-					
-				}
-				
-				$col = null;
-				
-				switch ($_REQUEST['name'])
-				{
-					
-					case 'name': $col = 'name'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'filename': $col = 'filename'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'file_encoding': $col = 'file_encoding'; break;
-					case 'format': $col = 'format'; break;
-					case 'field_delimiter': $col = 'field_delimiter'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-		   	  		case 'field_enclosure': $col = 'field_enclosure'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'field_escape': $col = 'field_escape'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'order_online': $col = 'order_online'; break;
-					case 'field_delimiter': $col = 'field_delimiter'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'field_enclosure': $col = 'field_enclosure'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'field_escape': $col = 'field_escape'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'order_onetime': $col = 'order_onetime'; break;
-					case 'csv_fieldnames': $col = 'csv_fieldnames'; break; 
-					case 'cron_interval': $col = 'cron_interval'; break;
-					case 'cron_path': $col = 'cron_path'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
-					case 'xml_roottag': $col = 'xml_roottag'; break;
-					case 'xml_ordertag': $col = 'xml_ordertag'; break;
-					case 'xml_productroottag': $col = 'xml_productroottag'; break;
-					case 'xml_customertag': $col = 'xml_customertag'; break;
-					case 'xml_producttag': $col = 'xml_producttag'; break;
-															
-					default: throw new \Exception(__('UngÃŒltiger Feldname (Profil)', 'wpsg'));
-					
-				}
-
-				$this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE, array(
-					wpsg_q($col) => wpsg_q($_REQUEST['value']) 
-				), " `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
-												
-				echo $this->db->fetchOne("SELECT `".wpsg_q($col)."` FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil_id'])."' "); 
-				exit;
-				 
-			}
-			else if ($_REQUEST['do'] == 'musterupload')
-			{
-				
-				$arProfil = $this->loadProfil($_REQUEST['profil_id']);
-						 
-				if ($arProfil['file_encoding'] == self::ENCODING_ISO88591)
-				{
-
-					$strFileContent = wpsg_toUtf8(file_get_contents($_FILES['file']['tmp_name']));
-					
-				}
-				else
-				{
-				
-					$strFileContent = file_get_contents($_FILES['file']['tmp_name']);
-					
-				}
-
-				if ($arProfil['format'] == self::FORMAT_CSV)
-				{
-									
-					// Alles nach erstem Zeilenumbruch entfernen
-					$strFileContent = preg_replace("/\r(.*)/s", "", $strFileContent);
-	
-					$arFields = explode($arProfil['field_delimiter'], $strFileContent);
-					 
-					if (sizeof($arFields) > 1) 
-					{
-						 						
-						foreach ($arFields as $f) 
-						{
-								
-							// Hochkommas am Anfang und am Ende abtrennen
-							if (preg_match('/^\"(.*)\"$/', $f)) $f = substr($f, 1, strlen($f) - 2);
-	
-							// Existiert das Feld schon
-							$existID = $this->db->fetchOne("SELECT `id` FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `profil_id` = '".wpsg_q($_REQUEST['profil_id'])."' AND `name` = '".wpsg_q($f)."' ");
-							
-							if (!wpsg_isSizedInt($existID))
-							{
-							
-								$this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
-									'profil_id' => wpsg_q($_REQUEST['profil_id']),
-									'name' => wpsg_q($f),
-									'value_key' => '-1'
-								));
-								
-							} 						
-							
-						}
-					
-					}
-										
-				}
-					
-				$this->shop->addBackendMessage(__('Muster Datei erfolgreich verarbeitet.', 'wpsg'));
-				
-				die($this->renderFields($this->loadProfil($_REQUEST['profil_id'])));
-								
-			}
-		
-		} // public function be_ajax()
-		
-		public function cron() 
-		{ 
-			
-			// Alle Profile laden, die automatisiert aufgerufen werden
-			$arProfile = $this->db->fetchAssoc("
+                    'value_key' => '-1'
+                ));
+
+                die($this->renderFields($this->loadProfil($_REQUEST['profil_id'])));
+
+            }
+            else if ($_REQUEST['do'] == 'wpsg_mod_export_profilSwitch')
+            {
+
+                die($this->renderProfil($_REQUEST['profil']));
+
+            }
+            else if ($_REQUEST['do'] == 'save')
+            {
+
+                $arProfil = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
+                $arProfil['fields'] = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `profil_id` = '".wpsg_q($arProfil['id'])."' ");
+
+                wpsg_header::startDownloadContent('profil.json', json_encode($arProfil));
+                exit;
+
+            }
+            else if ($_REQUEST['do'] == 'import')
+            {
+
+                $content = file_get_contents($_FILES['profil_file']['tmp_name']);
+                $content = wpsg_removeBOM($content);
+                $arData = @json_decode($content, true);
+
+                if (!wpsg_isSizedArray($arData))
+                {
+
+                    $this->shop->addBackendError(wpsg_translate(__('Datei ist keine gÃŒltige Profildatei. Error: #1#', 'wpsg'), json_last_error_msg()));
+
+                }
+                else
+                {
+
+                    $arFields = $arData['fields']; unset($arData['fields']);
+
+                    unset($arData['id']);
+                    unset($arData['cron_lastrun']);
+
+                    $profil_id = $this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE, wpsg_q($arData), true);
+
+                    foreach ($arFields as $field_data)
+                    {
+
+                        unset($field_data['id']);
+                        $field_data['profil_id'] = $profil_id;
+
+                        $this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, wpsg_q($field_data), true);
+
+                    }
+
+                    $this->shop->addBackendMessage(wpsg_translate(__('Profil als "#1#" erfolgreich importiert.', 'wpsg'), $arData['name']));
+
+                }
+
+                $this->shop->redirect(WPSG_URL_WP.'wp-admin/admin.php?page=wpsg-Admin&action=module&modul=wpsg_mod_export');
+
+            }
+            else if ($_REQUEST['do'] == 'inlinedit')
+            {
+
+                if (preg_match('/field_/', $_REQUEST['name']) && !in_array($_REQUEST['name'], ['field_delimiter', 'field_enclosure', 'field_escape']))
+                {
+
+                    // Feldwert wurde bearbeitet
+                    $field_id = preg_replace('/(.*)\_/', '', $_REQUEST['name']);
+                    $col = preg_replace('/\_\d+$/', '', $_REQUEST['name']);
+
+                    switch ($col)
+                    {
+
+                        case 'field_name': $col = 'name'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                        case 'field_format': $col = 'format'; break;
+                        case 'field_userformat': $col = 'userformat'; break;
+                        case 'field_typ': $col = 'value_key'; break;
+                        case 'field_xml_att': $col = 'xml_att'; break;
+
+                        default: throw new \Exception(__('UngÃŒltiger Feldname (Feld)', 'wpsg'));
+
+                    }
+
+                    $this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
+                        wpsg_q($col) => wpsg_q(wpsg_xss($_REQUEST['value']))
+                    ), " `id` = '".wpsg_q($field_id)."' ");
+
+                    echo $this->db->fetchOne("SELECT `".wpsg_q($col)."` FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `id` = '".wpsg_q($field_id)."' ");
+                    exit;
+
+                }
+                else if (preg_match('/orderfilter_/', $_REQUEST['name']))
+                {
+
+                    // Wert aus dem Bestellfilter wurde bearbeitet					
+                    $col = substr($_REQUEST['name'], 12);
+
+                    switch ($col)
+                    {
+
+                        case 's': $col = 's'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                        case 'k_id': $col = 'k_id'; break;
+                        case 'status': $col = 'status'; break;
+                        case 'cdate_m': $col = 'cdate_m'; break;
+                        case 'cdate_y': $col = 'cdate_y'; break;
+                        case 'invoicedate_m': $col = 'invoicedate_m'; break;
+                        case 'productgroup_ids': $col = 'productgroup_ids'; break;
+                        case 'productcategory_ids': $col = 'productcategory_ids'; break;
+
+                        default: throw new \Exception(__('UngÃŒltiger Feldname (Bestellfilter)', 'wpsg'));
+
+                    }
+
+                    $orderfilter = $this->db->fetchOne("SELECT `orderfilter` FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
+                    $orderfilter = @unserialize($orderfilter);
+                    if (!is_array($orderfilter)) $orderfilter = array();
+
+                    $orderfilter[$col] = $_REQUEST['value'];
+
+                    $this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE, array('orderfilter' => wpsg_q(serialize($orderfilter))), " `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
+
+                    echo $orderfilter[$col];
+                    exit;
+
+                }
+
+                $col = null;
+
+                switch ($_REQUEST['name'])
+                {
+
+                    case 'name': $col = 'name'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'filename': $col = 'filename'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'file_encoding': $col = 'file_encoding'; break;
+                    case 'format': $col = 'format'; break;
+                    case 'field_delimiter': $col = 'field_delimiter'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'field_enclosure': $col = 'field_enclosure'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'field_escape': $col = 'field_escape'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'order_online': $col = 'order_online'; break;
+                    case 'field_delimiter': $col = 'field_delimiter'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'field_enclosure': $col = 'field_enclosure'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'field_escape': $col = 'field_escape'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'order_onetime': $col = 'order_onetime'; break;
+                    case 'csv_fieldnames': $col = 'csv_fieldnames'; break;
+                    case 'cron_interval': $col = 'cron_interval'; break;
+                    case 'cron_path': $col = 'cron_path'; $_REQUEST['value'] = wpsg_sinput("text_field", $_REQUEST['value']); break;
+                    case 'xml_roottag': $col = 'xml_roottag'; break;
+                    case 'xml_ordertag': $col = 'xml_ordertag'; break;
+                    case 'xml_productroottag': $col = 'xml_productroottag'; break;
+                    case 'xml_customertag': $col = 'xml_customertag'; break;
+                    case 'xml_producttag': $col = 'xml_producttag'; break;
+
+                    default: throw new \Exception(__('UngÃŒltiger Feldname (Profil)', 'wpsg'));
+
+                }
+
+                $this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE, array(
+                    wpsg_q($col) => wpsg_q($_REQUEST['value'])
+                ), " `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
+
+                echo $this->db->fetchOne("SELECT `".wpsg_q($col)."` FROM `".WPSG_TBL_EXPORTPROFILE."` WHERE `id` = '".wpsg_q($_REQUEST['profil_id'])."' ");
+                exit;
+
+            }
+            else if ($_REQUEST['do'] == 'musterupload')
+            {
+
+                $arProfil = $this->loadProfil($_REQUEST['profil_id']);
+
+                if ($arProfil['file_encoding'] == self::ENCODING_ISO88591)
+                {
+
+                    $strFileContent = wpsg_toUtf8(file_get_contents($_FILES['file']['tmp_name']));
+
+                }
+                else
+                {
+
+                    $strFileContent = file_get_contents($_FILES['file']['tmp_name']);
+
+                }
+
+                if ($arProfil['format'] == self::FORMAT_CSV)
+                {
+
+                    // Alles nach erstem Zeilenumbruch entfernen
+                    $strFileContent = preg_replace("/\r(.*)/s", "", $strFileContent);
+
+                    $arFields = explode($arProfil['field_delimiter'], $strFileContent);
+
+                    if (sizeof($arFields) > 1)
+                    {
+
+                        foreach ($arFields as $f)
+                        {
+
+                            // Hochkommas am Anfang und am Ende abtrennen
+                            if (preg_match('/^\"(.*)\"$/', $f)) $f = substr($f, 1, strlen($f) - 2);
+
+                            // Existiert das Feld schon
+                            $existID = $this->db->fetchOne("SELECT `id` FROM `".WPSG_TBL_EXPORTPROFILE_FIELDS."` WHERE `profil_id` = '".wpsg_q($_REQUEST['profil_id'])."' AND `name` = '".wpsg_q($f)."' ");
+
+                            if (!wpsg_isSizedInt($existID))
+                            {
+
+                                $this->db->ImportQuery(WPSG_TBL_EXPORTPROFILE_FIELDS, array(
+                                    'profil_id' => wpsg_q($_REQUEST['profil_id']),
+                                    'name' => wpsg_q($f),
+                                    'value_key' => '-1'
+                                ));
+
+                            }
+
+                        }
+
+                    }
+
+                }
+
+                $this->shop->addBackendMessage(__('Muster Datei erfolgreich verarbeitet.', 'wpsg'));
+
+                die($this->renderFields($this->loadProfil($_REQUEST['profil_id'])));
+
+            }
+
+        } // public function be_ajax()
+
+        public function cron()
+        {
+
+            // Alle Profile laden, die automatisiert aufgerufen werden
+            $arProfile = $this->db->fetchAssoc("
 				SELECT
 					EXP.`id`, EXP.`cron_interval`, EXP.`cron_lastrun`, EXP.`orderfilter`, EXP.`cron_path`, EXP.`filename`, EXP.`format`, EXP.`export_type`
@@ -622,109 +622,109 @@
 					EXP.`cron_interval` > 0
 			");
-			
-			foreach ($arProfile as $profil)
-			{
-				
-				if ($profil['cron_lastrun'] == '0000-00-00') $cron_lastrun = 0;
-				else $cron_lastrun = strtotime($profil['cron_lastrun']);
-				
-				$bRun = false;
-				if ($cron_lastrun <= 0) $bRun = true;
-				else 
-				{
-					
-					switch ($profil['cron_interval'])
-					{
-						
-						case self::CRON_LIVE: 
-							
-							$bRun = true;
-							break;
-						
-						case self::CRON_DAILY:
-							
-							if (strtotime("+1 day", $cron_lastrun) < time()) $bRun = true;
-							break;
-						
-						case self::CRON_MONTHLY:
-							
-							if (strtotime("+1 month", $cron_lastrun) < time()) $bRun = true;
-							break;
-						
-						case self::CRON_WEEKLY:
-							
-							if (strtotime("+1 week", $cron_lastrun) < time()) $bRun = true;
-							break;
-						
-					}
-					
-				}
-				
-				if ($bRun === true)
-				{
-					
-					$arFilter = @unserialize($profil['orderfilter']);
-					if (!wpsg_isSizedArray($arFilter)) $arFilter = array();
-					
-					if ($profil['export_type'] == self::TYPE_ORDER)
-					{
-                    
-						if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportCSV($profil['id'], $arFilter);
-                    	else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportXML($profil['id'], $arFilter);
-						
-					}
-					else if ($profil['export_type'] == self::TYPE_PRODUCT)
-					{
-						
-						if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportProductCSV($profil['id'], $arFilter);
-                    	else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportProductXML($profil['id'], $arFilter);
-						
-					}
-					else if ($profil['export_type'] == self::TYPE_CUSTOMER)
-					{
-						
-						if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportCustomerCSV($profil['id'], $arFilter);
-                    	else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportCustomerXML($profil['id'], $arFilter);
-						
-					}
-					else if ($profil['export_type'] == self::TYPE_ABO)
-					{
-					
-						if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportAboCSV($profil['id'], $arFilter);
-						else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportAboXML($profil['id'], $arFilter);
-					
-					}
-					
+
+            foreach ($arProfile as $profil)
+            {
+
+                if ($profil['cron_lastrun'] == '0000-00-00') $cron_lastrun = 0;
+                else $cron_lastrun = strtotime($profil['cron_lastrun']);
+
+                $bRun = false;
+                if ($cron_lastrun <= 0) $bRun = true;
+                else
+                {
+
+                    switch ($profil['cron_interval'])
+                    {
+
+                        case self::CRON_LIVE:
+
+                            $bRun = true;
+                            break;
+
+                        case self::CRON_DAILY:
+
+                            if (strtotime("+1 day", $cron_lastrun) < time()) $bRun = true;
+                            break;
+
+                        case self::CRON_MONTHLY:
+
+                            if (strtotime("+1 month", $cron_lastrun) < time()) $bRun = true;
+                            break;
+
+                        case self::CRON_WEEKLY:
+
+                            if (strtotime("+1 week", $cron_lastrun) < time()) $bRun = true;
+                            break;
+
+                    }
+
+                }
+
+                if ($bRun === true)
+                {
+
+                    $arFilter = @unserialize($profil['orderfilter']);
+                    if (!wpsg_isSizedArray($arFilter)) $arFilter = array();
+
+                    if ($profil['export_type'] == self::TYPE_ORDER)
+                    {
+
+                        if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportCSV($profil['id'], $arFilter);
+                        else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportXML($profil['id'], $arFilter);
+
+                    }
+                    else if ($profil['export_type'] == self::TYPE_PRODUCT)
+                    {
+
+                        if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportProductCSV($profil['id'], $arFilter);
+                        else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportProductXML($profil['id'], $arFilter);
+
+                    }
+                    else if ($profil['export_type'] == self::TYPE_CUSTOMER)
+                    {
+
+                        if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportCustomerCSV($profil['id'], $arFilter);
+                        else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportCustomerXML($profil['id'], $arFilter);
+
+                    }
+                    else if ($profil['export_type'] == self::TYPE_ABO)
+                    {
+
+                        if ($profil['format'] == self::FORMAT_CSV) $file = $this->handleExportAboCSV($profil['id'], $arFilter);
+                        else if ($profil['format'] == self::FORMAT_XML) $file = $this->handleExportAboXML($profil['id'], $arFilter);
+
+                    }
+
                     if (wpsg_remoteconnection::handleConenctionString($profil['cron_path'], $profil['filename'], $file) !== true)
-					{
-						
-						$target_path = $profil['cron_path'];
-						if (is_dir($target_path)) $target_path = $target_path.'/'.$profil['filename'];
-									
-						file_put_contents($target_path, file_get_contents($file));
-												
-					}
-									
-					// Letzte AusfÃŒhrung speichern
-					$this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE, array(
-						'cron_lastrun' => 'NOW()'
-					), " `id` = '".wpsg_q($profil['id'])."' ");
-					
-				}
-				
-			}
-			
-		} // public function cron()
-		
-		/* Modulfunktionen */
-
-		/**
-		 * Gibt einen Array der Profile aus der Datenbank zurÃŒck
-		 * @param Array $type
-		 */
-		public function getProfile($type)
-		{
-			
-			return $this->db->fetchAssoc("
+                    {
+
+                        $target_path = $profil['cron_path'];
+                        if (is_dir($target_path)) $target_path = $target_path.'/'.$profil['filename'];
+
+                        file_put_contents($target_path, file_get_contents($file));
+
+                    }
+
+                    // Letzte AusfÃŒhrung speichern
+                    $this->db->UpdateQuery(WPSG_TBL_EXPORTPROFILE, array(
+                        'cron_lastrun' => 'NOW()'
+                    ), " `id` = '".wpsg_q($profil['id'])."' ");
+
+                }
+
+            }
+
+        } // public function cron()
+
+        /* Modulfunktionen */
+
+        /**
+         * Gibt einen Array der Profile aus der Datenbank zurÃŒck
+         * @param Array $type
+         */
+        public function getProfile($type)
+        {
+
+            return $this->db->fetchAssoc("
 				SELECT
 					P.*
